#!/usr/bin/env python
# Part of an exercise for introducing classes
# Author:  Yotam Medini  yotam.medini@gmail.com -- Created: 2008/October/31

import sys

import heshe


def show_persons(persons, msg):
    sys.stdout.write("\n%s:\n" % msg)
    for p in persons:
        p.fshow(sys.stdout)
    sys.stdout.write("\n")


def new_children(papa, mama, chidlren):
    for p in [papa, mama]:
        for c in chidlren:
            p.add_child(c)


def future_advance(persons, years):
    for p in persons:
        p.age += years


def future_show(persons, years, msg):
    future_advance(persons, years)
    show_persons(persons, msg)


avram = heshe.Man("Avraham", 90)
sara = heshe.Woman("Sarah", 80)
all = [avram, sara]
show_persons(all, "Before the angels")


# 10 years later
isma = heshe.Man("Yishmael", 5)
itzik = heshe.Man("Itzhack", 1)
all.append(isma)
all.append(itzik)
new_children(avram, sara, [isma, itzik])
ny = 10
future_show(all, ny, "%d years later" % ny)

# 30 years later
riki = heshe.Woman("Rivka", 30)
esav = heshe.Boy("Esav", 1)
kobi = heshe.Boy("Jacob", 1)
ada = heshe.Girl("Ada", 0)
kobi.add_child(ada) # Should fail...
all = [itzik, riki, esav, kobi, ada]
new_children(itzik, riki, [esav, kobi])
ny = 30
future_show(all, ny, "%d years later" % ny)

# 40 years later
kobi = heshe.Man("Jacob", 40)  # Now a man and can have children
lea = heshe.Woman("Lea", 32)
rubi = heshe.Man("Reuven", 13)
shimi = heshe.Boy("Shimon", 12)
dina = heshe.Girl("Dina", 11)
new_children(kobi, lea, [rubi, shimi, dina])
all = [kobi, lea, rubi, shimi, dina]
show_persons(all, "The end")

sys.exit(0)
